#ifndef __DEBLOCK__
#define __DEBLOCK__

#include "avisynth.h"
#include "yuy2planes.h"

class Deblock : public GenericVideoFilter {
private:
   bool mmx, isse;
   int nQuant;
   int nAOffset, nBOffset;
   int nWidth, nHeight;

   static inline int sat(int x, int min, int max)
   { return (x < min) ? min : ((x > max) ? max : x); }

   static inline int abs(int x)
   { return ( x < 0 ) ? -x : x; }

   static void DeblockHorEdge(unsigned char *srcp, int srcPitch, int ia, int ib);

   static void DeblockVerEdge(unsigned char *srcp, int srcPitch, int ia, int ib);

	YUY2Planes * SrcPlanes;

public:
   static void DeblockPicture(unsigned char *srcp, int srcPitch, int w, int h,
                              int q, int aOff, int bOff);

	Deblock(PClip _child, int q, int aOff, int bOff, bool _mmx, bool _isse, 
           IScriptEnvironment* env);
   ~Deblock();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

#endif