// YUY2 <-> planar
// Copyright(c)2005 A.G.Balakhnin aka Fizick

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .
#include "yuy2planes.h"

YUY2Planes::YUY2Planes(int _nWidth, int _nHeight)
{
	nWidth = _nWidth;
	nHeight = _nHeight;
	srcPitch = (nWidth + 15) & (~15);
	srcPitchUV = (nWidth + 15) & (~15);
	pSrc = (unsigned char*) malloc(srcPitch*nHeight);   
	pSrcU = (unsigned char*) malloc(srcPitchUV*nHeight);   
	pSrcV = (unsigned char*) malloc(srcPitchUV*nHeight);

}   

YUY2Planes::~YUY2Planes()
{
	free (pSrc);
	free (pSrcU);
	free (pSrcV);
}


void YUY2ToPlanes(const unsigned char *pSrcYUY2, int nSrcPitchYUY2, int nWidth, int nHeight,
							  const unsigned char * pSrc0, int _srcPitch,
							  const unsigned char * pSrcU0, const unsigned char * pSrcV0, int _srcPitchUV)
{
	unsigned char * pSrc1 = (unsigned char *) pSrc0;
	unsigned char * pSrcU1 = (unsigned char *) pSrcU0;
	unsigned char * pSrcV1 = (unsigned char *) pSrcV0;
	for (int h=0; h<nHeight; h++)
	{
		for (int w=0; w<nWidth; w+=2)
		{
			int w2 = w+w;
			pSrc1[w] = pSrcYUY2[w2];
			pSrcU1[w>>1] = pSrcYUY2[w2+1];
			pSrc1[w+1] = pSrcYUY2[w2+2];
			pSrcV1[w>>1] = pSrcYUY2[w2+3];
		}
		pSrc1 += _srcPitch;
		pSrcU1 += _srcPitchUV;
		pSrcV1 += _srcPitchUV;
		pSrcYUY2 += nSrcPitchYUY2;
	}
}

void YUY2FromPlanes(unsigned char *pSrcYUY2, int nSrcPitchYUY2, int nWidth, int nHeight,
							  unsigned char * pSrc1, int _srcPitch,
							  unsigned char * pSrcU1, unsigned char * pSrcV1, int _srcPitchUV)
{
	for (int h=0; h<nHeight; h++)
	{
		for (int w=0; w<nWidth; w+=2)
		{
			int w2 = w+w;
			pSrcYUY2[w2] = pSrc1[w];
			pSrcYUY2[w2+1] = pSrcU1[w>>1];
			pSrcYUY2[w2+2] = pSrc1[w+1];
			pSrcYUY2[w2+3] = pSrcV1[w>>1];
		}
		pSrc1 += _srcPitch;
		pSrcU1 += _srcPitchUV;
		pSrcV1 += _srcPitchUV;
		pSrcYUY2 += nSrcPitchYUY2;
	}
}

